      Subroutine cas_lheinit
      Implicit None
#include "caslujets.inc"
#include "caseffic.inc"
      character*512 hepmcout,lhefile
      common/CAHEPMCOUT/hepmcout,lhefile
      LOGICAL ex
      Integer lun,ipr, ievent
      character* 200 string
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/
ccc replace nr of event with nr of event found in file
	Integer Nevent
	Common/steer1/Nevent
      
      lun = 25
      ievent=0
      inquire(FILE=lhefile,EXIST=ex)
      if(ex) then
	   Write(6,*) ' File exists ',lhefile
         OPEN(lun,FILE=lhefile,STATUS='OLD',ERR=100)
         else
         write(6,*) '*           input lhe file ',lhefile,' not found    *'
         write(6,*) '*           Program stopped                         *'
         write(6,*) '*****************************************************'
         stop
      endif
 1    continue
      string=' '
      read(lun,fmt='(a)',err=777,end=666) string
      if(string(1:6).eq.'<init>') then
         read(lun,*) idbmup(1),idbmup(2),ebmup(1),ebmup(2),
     &        pdfgup(1),pdfgup(2),pdfsup(1),pdfsup(2),idwtup,nprup
         do ipr=1,nprup
            read(lun,*) xsecup(ipr),xerrup(ipr),xmaxup(ipr),
     &           lprup(ipr)
         avgi = xsecup(ipr)
         sd = xerrup(ipr)
         enddo
         goto 1
      elseif(string(1:6).eq.'<event') then
         ievent = ievent + 1
         goto 1
      else 
         goto 1
      endif
 
999   return
         
100	Write(6,*) ' Error! File open failed for cascade.lhe  STOP '
      return
777   Write(6,*) ' Error! reading file   '
      return
666   Write(6,*) ' End of  file   ',ievent
      nevent = ievent
      rewind lun
      return     
      End
      
      Subroutine cas_lheread
c this is a copy of lheread from powheg      
      Implicit None
#include "caslujets.inc"
#include "casludat1.inc"
#include "casludat2.inc"
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/
      character* 200 string
      Integer lun,i,j,iup,i1,i2,i3,i4,ILBL,ISDE1,ISDE2,IUP1,IUP2,NLBL,NMAT
      Integer KUPPO(100),ILAB(100),IUPDAU
      Integer Nf_part
      Common/lheinfo/Nf_part
      Integer ncall
      data ncall/0/
c initialise tmp arrayz
      do i=1,100
        kuppo(i) = 0
        ilab(i) = 0
      end do

      lun = 25
c       write(6,*) ' dummy version of cas_lheread '
      
 1    continue
      string=' '
      read(lun,fmt='(a)',err=777,end=666) string
      if(string.eq.'</LesHouchesEvents>') then
         goto 998
      endif

      if(string(1:6).eq.'<event') then
c on error try next event. The error may be caused by merging
c truncated event files. Thus we are tolerant about it.
c Only on EOF return with no event found
         read(lun,*,end=998,err=1)nup,idprup,xwgtup,scalup,aqedup,aqcdup
         do i=1,nup
            read(lun,*,end=998,err=1) idup(i),istup(i),mothup(1,i),
     &           mothup(2,i),icolup(1,i),icolup(2,i),(pup(j,i),j=1,5),
     &           vtimup(i),spinup(i)
         end do
         ncall = ncall + 1 
         Nf_part = nup-2
         do  I=1,MSTU(4)
           do  J=1,5
           K(I,J)=0
           P(I,J)=0.D0
           V(I,J)=0.d0
           end do
         end do
         
c         write(6,*) ' after read '
         call PYUPRE
         if (ncall .le.10) call pylist(7)
         K(1,1)=21
         K(1,2)=idbmup(1)
         K(2,2)=idbmup(2)
         K(2,1)=21
         P(1,4)=ebmup(1)
         P(1,3)=-ebmup(1)
         P(1,5) = 0
         P(2,4)=ebmup(2)
         P(2,3)=ebmup(2)
         P(2,5) = 0
         I=2

C this is taken form pythia (pyrand)
        KUPPO(1)=1
        KUPPO(2)=2

c         DO 470 IUP=1,NUP
c          KUPPO(IUP)=0
c          I=I+1
c          KUPPO(IUP)=I
c          K(I,1)=21
c          K(I,2)=IDUP(IUP)
c          IF(IDUP(IUP).EQ.0) K(I,2)=90
c          K(I,3)=0
c          IF(MOTHUP(1,IUP).GE.3) K(I,3)=KUPPO(MOTHUP(1,IUP))
c          K(I,4)=0
c          K(I,5)=0
c          DO 460 J=1,5
c            P(I,J)=PUP(J,IUP)
c  460     CONTINUE
c          V(I,5)=VTIMUP(IUP)
c  470    CONTINUE
         N=I
C...Store final state partons for user-defined processes
c         N=2
        DO 490 IUP=1,NUP
          N=N+1
          K(N,1)=1
          IF(ISTUP(IUP).EQ.2.OR.ISTUP(IUP).EQ.3) K(N,1)=11
          K(N,2)=IDUP(IUP)
          IF(IDUP(IUP).EQ.0) K(N,2)=90
          IF(MOTHUP(1,IUP).EQ.0) THEN
            K(N,3)=KUPPO(IUP)
          ELSE
            K(N,3)=MOTHUP(1,IUP)
          ENDIF
          K(N,4)=0
          K(N,5)=0
C...Search for daughters of intermediate colourless particles.
          IF(K(N,1).EQ.11.AND.KCHG(PYCOMP(K(N,2)),2).EQ.0) THEN
            DO 475 IUPDAU=IUP+1,NUP
              IF(MOTHUP(1,IUPDAU).EQ.IUP.AND.K(N,4).EQ.0) K(N,4)=
     &        N+IUPDAU-IUP
              IF(MOTHUP(1,IUPDAU).EQ.IUP) K(N,5)=N+IUPDAU-IUP
  475       CONTINUE
          ENDIF
          DO 480 J=1,5
            P(N,J)=PUP(J,IUP)
  480     CONTINUE
          V(N,5)=VTIMUP(IUP)
  490   CONTINUE
c         write(6,*) ' before color flow '
c         call pylist(2)
C...Arrange colour flow for user-defined processes
        NLBL=0
        DO 540 IUP1=1,NUP
          I1=I+IUP1
          IF(KCHG(PYCOMP(K(I1,2)),2).EQ.0) GOTO 540
          IF(K(I1,1).EQ.1) K(I1,1)=3
          IF(K(I1,1).EQ.11) K(I1,1)=14
C...Find a not yet considered colour/anticolour line.
          DO 530 ISDE1=1,2
            IF(ICOLUP(ISDE1,IUP1).EQ.0) GOTO 530
            NMAT=0
            DO 500 ILBL=1,NLBL
              IF(ICOLUP(ISDE1,IUP1).EQ.ILAB(ILBL)) NMAT=1
  500       CONTINUE
            IF(NMAT.EQ.0) THEN
              NLBL=NLBL+1
              ILAB(NLBL)=ICOLUP(ISDE1,IUP1)
C...Find all others belonging to same line.
              I3=I1
              I4=0
              DO 520 IUP2=IUP1+1,NUP
                I2=2+IUP2
                DO 510 ISDE2=1,2
                  IF(ICOLUP(ISDE2,IUP2).EQ.ICOLUP(ISDE1,IUP1)) THEN
                    IF(ISDE2.EQ.ISDE1) THEN
                      K(I3,3+ISDE2)=K(I3,3+ISDE2)+I2
                      K(I2,3+ISDE2)=K(I2,3+ISDE2)+MSTU(5)*I3
                      I3=I2
                    ELSEIF(I4.NE.0) THEN
                      K(I4,3+ISDE2)=K(I4,3+ISDE2)+I2
                      K(I2,3+ISDE2)=K(I2,3+ISDE2)+MSTU(5)*I4
                      I4=I2
                    ELSEIF(IUP2.LE.2) THEN
                      K(I1,3+ISDE1)=K(I1,3+ISDE1)+I2
                      K(I2,3+ISDE2)=K(I2,3+ISDE2)+I1
                      I4=I2
                    ELSE
                      K(I1,3+ISDE1)=K(I1,3+ISDE1)+MSTU(5)*I2
                      K(I2,3+ISDE2)=K(I2,3+ISDE2)+MSTU(5)*I1
                      I4=I2
                    ENDIF
                  ENDIF
  510           CONTINUE
  520         CONTINUE
            ENDIF
  530     CONTINUE
  540   CONTINUE
         
c         write(6,*) ' after color flow '       
c         call pylist(2)
c         goto 1
      else
         goto 1
      endif
c no event found:
      return
 777  continue
      print *,"Error in reading"
      print *,string
      nup=0
      return
 666  continue
      print *,"reached EOF"
      print *,string
      nup=0
      return
 998  continue
      print *,"read </LesHouchesEvents>"
      nup=0      
 999  Continue
      return
      end
 
      
      Subroutine cas_lheprocess
      Implicit None
#include "caslujets.inc"
#include "caspart.inc"
#include "casludat1.inc"
#include "caspar.inc"
#include "caspara5.inc"
#include "casluco.inc"
#include "casgki.inc"
	Double Precision xg1,xg1_bar,yx1,yx1_bar 
	Double Precision xg2,xg2_bar,yx2,yx2_bar 
	Common /resolv/xg1,xg1_bar,yx1,yx1_bar,xg2,xg2_bar,yx2,yx2_bar
      Integer Nf_part
      Common/lheinfo/Nf_part
      DOUBLE PRECISION DETOT,DBETA,STHETA,SPHI
      COMMON /MYBOOST/ DETOT,DBETA(2,3),STHETA(2),SPHI(2)
      Double Precision XPY,SH
      Integer KFL
      COMMON /MYPROC/KFL(3,2),XPY(2),SH
      Double Precision dboost
      Integer NVMAX
	Parameter (NVMAX=5000)
      Double Precision PS(nvmax,5),PSAVE(2,5)
      Integer KS(nvmax,5)
      Double Precision dot1,dot
      Integer I,J,NS,ii
      Integer IPU1,IPU2
     
      Double Precision sqrts
      Double Precision yph,yph_bar
      
      Double Precision PFIN(4),QMAX
      

c      NB2 = 2
c      NIPH = 3
c      UMAS2 = PYMASS(K(2,2))**2
c.hju parl(21) = 2P.k = invariant mass s
cc      PARL(21) = 2.D0*DOT1(1,2)
c.hju parl(22) = 2P.q P = proton q = photon
c      PARL(22) = 2.D0*DOT1(NB2,NIPH)
C... CALCULATE CMS ENERGY
      DO 20 I=1,4
         CM(I) =P(1,I)+P(2,I)
   20 CONTINUE
C BOOST TO CMS
      CALL PYROBO(0,N,0.D0,0.D0,-CM(1)/CM(4),-CM(2)/CM(4),-CM(3)/CM(4))
      DO  I=1,2
         DO  J=1,5
            PBEAM(I,J)=P(I,J)
            KBEAM(I,J)=K(I,J)  
         End do
      End do    
C BOOST Back CMS
      CALL PYROBO(0,N,0.D0,0.D0,CM(1)/CM(4),CM(2)/CM(4),CM(3)/CM(4))
      KINT(1,2)= K(1,2)
      KINT(2,2)= K(2,2)     
      SSS = DOT(CM,CM)
      sqrts=dsqrt(sss)
      ISEMIH = 1
      KFL(2,1)=K(3,2)
      KFL(2,2)=K(4,2)
      KFL(1,1)=KFL(2,1)
      KFL(1,2)=KFL(2,2)
      PYVAR(2)=2.D0*DOT1(1,2)
      PYVAR(1)=SQRT(PYVAR(2))
      PYVAR(3)=P(1,5)
      PYVAR(4)=P(2,5)
      PYVAR(5)=PYVAR(1)/2.
c check this 
c      PYVAR(31) = P(3,4)/P(1,4)
c      PYVAR(32) = P(4,4)/P(2,4)
c      write(6,*) " cas_lheprocess ",PYVAR(1),PYVAR(31),PYVAR(32)
c      write(6,*) " lightcone ",(P(3,4)-P(3,3))/sqrts,(P(3,4)+P(3,3))/sqrts, (P(4,4)-P(4,3))/sqrts,(P(4,4)+P(4,3))/sqrts
      xg     = (P(3,4)+P(3,3))/sqrts
c      xg_bar = (P(3,4)-P(3,3))/sqrts
      xg1     = (P(4,4)-P(4,3))/sqrts
c      yph_bar = (P(4,4)+P(4,3))/sqrts
      PYVAR(31) = xg
      PYVAR(32) = xg1
      do I=1,5
            PSAVE(1,I)=P(1,I)
            PSAVE(2,I)=P(2,I)
      End do
      DBETA(2,1)=0d0
      DBETA(2,2)=0d0
      SPHI(2)=0d0
      STHETA(2)=0d0
      dboost = (PYVAR(31)-PYVAR(32))/
     &            (PYVAR(31)+PYVAR(32))
      DBETA(2,3)=dboost
c      call pylist(1)
C...Transform to g g cms, boost parameters in double precision.
      CALL PYROBO(3,0,0d0,0d0,0.0d0,0.0d0,-dboost)
c      write(6,*) ' before event record rearrangement '
c      call pylist(1)
C...Save event record in  cms
      do I=1,N
         do J=1,5
            KS(I,J)=K(I,J)
            PS(I,J)=P(I,J)
         end do
      end do
C...Partons with colour information in hadronic cms frame.
      DO 60  I=20,MSTU(4)
         DO 60 J=1,5
            K(I,J)=0
            P(I,J)=0.D0
   60 V(I,J)=0.d0
      NS=20
      do  J=1,5
         N=NS+7
         K(NS+1,J)=K(3,J)
         P(NS+1,J)=P(3,J)
         K(NS+3,J)=K(4,J)
         P(NS+3,J)=P(4,J)
c         K(NS+5,J)=K(5,J)
c         P(NS+5,J)=P(5,J)
c         K(NS+6,J)=K(8,J)
c         P(NS+6,J)=P(8,J)
      end do
C...Old standard continuation lines
c      K(NS+2,1)=-1
c      K(NS+2,3)=NS+1
c      K(NS+4,1)=-1
c      K(NS+4,3)=NS+3
c      P(NS+4,3)=27
c      P(NS+4,4)=27
C...Origin and Colour info for incoming parton
      K(NS+1,1)=13
      K(NS+3,1)=13
      do i=5,8
c      write(6,*) ' K... ',i,K(i,4),K(i,5)
      if(k(i,4)/10000.eq.3) k(i,4)=21*MSTU(5)
      if(k(i,5)/10000.eq.3) k(i,5)=21*MSTU(5)
      if(k(i,4)/10000.eq.4) k(i,4)=23*MSTU(5)
      if(k(i,5)/10000.eq.4) k(i,5)=23*MSTU(5)
c      write(6,*) ' K... ',i,K(i,4),K(i,5)
      enddo
      do i=21,23,2
c      write(6,*) ' K... ',i,K(i,4),K(i,5)
      if(k(i,4)/10000.eq.3) k(i,4)=21*MSTU(5)
      if(k(i,5)/10000.eq.3) k(i,5)=21*MSTU(5)
      if(k(i,4)/10000.eq.4) k(i,4)=23*MSTU(5)
      if(k(i,5)/10000.eq.4) k(i,5)=23*MSTU(5)
      if(k(i,4).eq.3) k(i,4)=21
      if(k(i,5).eq.3) k(i,5)=21
      if(k(i,4).eq.4) k(i,4)=23
      if(k(i,5).eq.4) k(i,5)=23
c      write(6,*) ' K... ',i,K(i,4),K(i,5)
      enddo
c      write(6,*) ' K... ',ns+1,K(ns+1,4),K(ns+1,5)
c      write(6,*) ' K... ',ns+3,K(ns+3,4),K(ns+3,5)
c      K(NS+3,3)=2
c      K(NS+3,4)=27
c      K(NS+3,5)=27
c check this for number of outgoing partons
c      DO 80  J=1,4
c         P(NS+7,J)=P(5,J)+P(6,J)+P(8,J)+P(8,J)
c   80 CONTINUE
c      P(NS+7,5)=DSQRT(DMAX1(0.D0, P(NS+7,4)**2-P(NS+7,1)**2-P(NS+
c     +7,2)**2- P(NS+7,3)**2))
c      N=NS+7
c      write(6,*) ' cas_lheprocess before caremn'
c      call pylist(1) 

c 
C...Generate timelike parton shower (if required)
      if(IPY(13).EQ.1) then
        do j=1,4
          Pfin(j)=0.
        end do
c final state particles
        nf1=5
        nf2=4+nf_part
        do i=nf1,nf2
          do J=1,4
          PFIN(J) = PFIN(J) + P(I,J)  
          End do
c          write(6,*) ' adding ',i,(P(i,j),j=1,4)
        End do
        QMAX=dsqrt(dot(PFIN,PFIN))
c        CALL PYSHOW(nf1,-nf2,Qmax/100.)
c        CALL PYSHOW(nf1+2,nf2,1.)
c        write(6,*) ' Qmax = ',qmax,nf_part,(PFIN(i),i=1,4)
      endif

c      write(6,*) ' after final state shower ',nf1,nf2
c      call pylist(1)
      
      IPU1=21
      IPU2=23
      IPY(41)=K(1,2)
      IPY(42)=K(2,2)
      IRES(1) = 1
      IRES(2) = 1
      ILEPTO =0 
      CALL CAREMN(IPU1,IPU2)
     
c      write(6,*) ' cas_lheprocess after caremn'
c rearrange event record
      ii = 0
      Do i=3,4
        ii = ii+1
        DO  J=1,5
         K(N+ii,J)=K(i,J)
         P(N+ii,J)=P(i,J)
        End do
      End do
      Nia1=3
      Nia2=5
c      NF1=7
c      NF2=8
c	K(25,3) = Nia1+1
c	K(26,3) = Nia2+1
	K(21,3)=3
	K(21,1)=21
	K(23,3)=4
	K(23,1)=21
	do J=1,5
c         K(Nia1,J)=K(N+1,J)
c         P(Nia1,J)=P(N+1,J)
c         K(Nia1+1,J)=K(21,J)
c         P(Nia1+1,J)=P(21,J)
c         K(Nia2,J)=K(N+2,J)
c         P(Nia2,J)=P(N+2,J)
c         K(Nia2+1,J)=K(23,J)
c         P(Nia2+1,J)=P(23,J)
c         K(NF1,J)=K(25,J)
c         P(NF1,J)=P(25,J)
c         K(NF2,J)=K(26,J)
c         P(NF2,J)=P(26,J)		
	end do
c      do i=1,10
c        do j=1,5
c        P(Nia2+1+i,j)=P(N+2+i,j)
c        K(Nia2+1+i,j)=K(N+2+i,j)
c        end do
c      end do
c	K(21,1)=0
c	K(23,1)=0
C...Zero irrelevant lines with K(I,1)<0
      do i=5,19
c      K(I,4)=0
      enddo
c	K(3,3)=1
c	K(Nia1+1,1)=21
c	K(Nia1+1,3)=3
c	K(Nia2+1,1)=21
c	K(Nia2+1,3)=5 
c	K(4,3)=3
c	K(5,1)=21
c	K(5,3)=2
c	K(6,1)=21
c	K(6,3)=5

             
      
c      call pylist(1) 
      call pyprep(0)
c      call pylist(1)
c      CALL pyedit(14)
c      call pylist(2)
      return
      end
